<?php

error_reporting(0);
set_time_limit(10);

$len_limit = 450;

// font
$fontname = trim($_GET['f']);
if ($fontname == '') $fontname = 'default';

$font  = imageloadfont($fontname.'.gdf');
if (!$font) $font = imageloadfont('default.gdf');
if (!$font) $font = 4;

//
$colorcode = trim($_GET ['c']);
if ($colorcode == '') $colorcode = '000000';

$bg = trim($_GET ['b']);
if ($bg == '') $bg = 'FFFFFF';


$spacing = intval(trim($_GET['s']));
if (empty($_GET['s']) || $spacing < 1 || $spacing > 5) $spacing = 3;

$width = intval(trim($_GET['w']));
if (empty($_GET['w']) || $width < 200 || $width > 600) $width = 500;

$padding_top = intval(trim($_GET['pt']));
if (empty($_GET['pt']) || $padding_top < 0 || $padding_top > 10) $padding_top = 3;

$padding_left = intval(trim($_GET['pl']));
if (empty($_GET['pl']) || $padding_left < 0 || $padding_left > 10) $padding_left = 1;

$author_line = intval(trim($_GET['a']));
if (empty($_GET['a']) || $author_line < 0 || $author_line > 10) $author_line = 3;


$imgformat = intval(trim($_GET['i']));

//
$url = trim($_GET['u']);
if ($url == '')
{
	$php_self = 'http://' . $_SERVER["HTTP_HOST"]. $_SERVER['PHP_SELF'];
	
	$html_message = <<< HEREDOC
<pre>
f - fontname  (e.g. default)
c - color code   (e.g. 000000)
b - background color code   (e.g. FFFFFF)
s - line spacing   (e.g. 3) (range = 1-5)
w - image width   (e.g. 500) (range = 200-600)
pt - top padding   (e.g. 3) (range = 0 - 10)
pl - left padding   (e.g. 1) (range = 0 - 10)
a - author line spacing   (e.g. 3) (range = 0 - 10)
i - image format   (e.g. 1) (default 0 = png, 1 = gif, 2 = jpeg)

u - url, without http://   (e.g. yoursite.com/random_quote.php)


Usage:

[img]$php_self?u=yoursite.com/random_quote.php[/img]
[img]$php_self?u=yoursite.com/random_quote.php&s=3&c=999999&pt=4[/img]
</pre>
HEREDOC;
die ($html_message);
}
else
{
	$url = 'http://'.$url;
	$string = trim(file_get_contents($url, FALSE));
	
	$len = strlen($string);
	
	if ($len = 0 || $len > $len_limit)
	{
		na();
	}
	else
	{
		output_image_and_die($string, $colorcode, $spacing, $font, $width, $padding_top, $padding_left, $author_line, $bg, $imgformat);
	}
}



function na()
{
	$string = "No quote available at this time.";
	output_image_and_die($string);
}

function output_image_and_die($string, $color=000000, $space=3, $font=4, $w=500, $padding_top = 3, $padding_left = 1, $author_line = 3, $bg=FFFFFF, $imgformat = 0) {
  
  if (strlen($color) != 6) $color = 000000;
  if (strlen($bg) != 6) $bg = FFFFFF;
  
  $h = imagefontheight($font);
  $fw = imagefontwidth($font);
  
  $text_block = explode('||', wordwrap($string, ($w / $fw), '||', true));
  
  $lines = count($text_block);
  
  $im = imagecreate(($w + $padding_left), (($h * $lines) + ($lines * $space) + $padding_top + $author_line));
  
  $int = hexdec($bg);
  $bg = imagecolorallocate($im, 0xFF & ($int >> 0x10), 0xFF & ($int >> 0x8), 0xFF & $int);
  
  $int = hexdec($color);
  $color = imagecolorallocate($im, 0xFF & ($int >> 0x10), 0xFF & ($int >> 0x8), 0xFF & $int);

	$x = $padding_left;
	$y = $padding_top;
	for ($i=0; $i < $lines; $i++)
	{
   		imagestring($im, $font, $x, $y, $text_block[$i], $color);
	   	if ($i != $lines - 2)
	   	{
			$y += ($h + $space);
		}
    	else
	    {
			$y += ($h + $space + $author_line);
		}
	}
  
  
	//(default 0 = png, 1 = gif, 2 = jpeg)
	if ($imgformat == 1)
	{
		header('Content-type: image/gif');
		die(imagegif($im));
	}
	elseif ($imgformat == 2)
	{
		header('Content-type: image/jpeg');
		die(imagejpeg($im));	
	}
	else
	{
		header('Content-type: image/png');
		die(imagepng($im));
	}
}

?>